// #autoload
// #name = UTZoom
// #category = ilys' Scripts

$newFOV = $pref::player::defaultFov;
$ZoomIn = false;

package UTZoom
{
function UTZoom(%val)
{
	if(%val)
	{
		if(!$ZoomOn) $newFOV = $pref::player::defaultFov;
		$ZoomOn = true;
		$ZoomIn = !$ZoomIn;
		if($ZoomIn) ZoomIn();
		else ZoomOut();
	}
	else
	{
		if($ZoomID !$= "") cancel($ZoomID);
	}
	if($newFOV == $pref::player::defaultFov) $ZoomOn = false;
}
function ZoomIn()
{
	if($ZoomID !$= "") cancel($ZoomID);
	if($newFOV == 5) return;
	$newFOV--;
	$pref::player::currentFOV = $newFOV;
	setFOV($newFOV);
	$ZoomID = schedule($pref::Player::zoomSpeed/10, 0, ZoomIn);
}
function ZoomOut()
{
	if($ZoomID !$= "") cancel($ZoomID);
	if($newFOV == $pref::player::defaultFov) return;
	$newFOV++;
	$pref::player::currentFOV = $newFOV;
	setFOV($newFOV);
	$ZoomID = schedule($pref::Player::zoomSpeed/10, 0, ZoomOut);
}
function ResetUTZoom()
{
	if($ZoomID !$= "") cancel($ZoomID);
	$newFOV = $pref::player::defaultFov;
	setFOV($newFOV);
	$ZoomOn = false;
	$ZoomIn = false;
}
function OptionsDlg::onWake(%this)
{
	if(!$UTSniperZoomKeys)
	{
		$RemapName[$RemapCount]="UT Zoom";
		$RemapCmd[$RemapCount]="UTZoom";
		$RemapCount++;
		$RemapName[$RemapCount]="Reset UT Zoom";
		$RemapCmd[$RemapCount]="ResetUTZoom";
		$RemapCount++;
		$UTSniperZoomKeys = 1;
	}
	parent::onWake(%this);
}
};
activatepackage(UTZoom);